#|
This file is part of Ordo.

Copyright (C) 2025 Ray Miller

This program is free software: you can redistribute it and/or modify it under
the terms of the GNU General Public License as published by the Free Software
Foundation, version 3.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see <https://www.gnu.org/licenses/>.
|#
(define-module (ordo core)
  #:use-module (oop goops)
  #:use-module (ordo blueprint)
  #:use-module (ordo connection)
  #:use-module (ordo context)
  #:use-module (ordo inventory)
  #:use-module (ordo logger)
  #:use-module (srfi srfi-26)
  #:export (execute))

(define-method (execute (blueprint <blueprint>) (conn <connection>))
  #f
  )

(define-method (execute (blueprint <blueprint>) (host <host>))
  (log-msg 'NOTICE "Executing blueprint " (blueprint-name blueprint) " on host " (host-name host))
  (call-with-connection (host-connection host) (cut execute blueprint <>)))

(define-method (execute (task <task>) (conn <connection>))
  #f)

(define-method (execute (task <task>) (host <host>))
  (log-msg 'NOTICE "Executing task " (task-name task) " on host " (host-name host))
  (call-with-connection (host-connection host) (cut execute task <>)))
